leetcode 494. 目标和

leetcode 494. 目标和

题目

给你一个非负整数数组 nums 和一个整数 target 。

向数组中的每个整数前添加 '+' 或 '-' ,然后串联起所有整数,可以构造一个 表达式 :

例如,nums = 2, 1 ,可以在 2 之前添加 '+' ,在 1 之前添加 '-' ,然后串联起来得到表达式 "+2-1" 。

返回可以通过上述方法构造的、运算结果等于 target 的不同 表达式 的数目。

示例 1:

输入:nums = 1,1,1,1,1, target = 3

输出:5

解释:一共有 5 种方法让最终目标和为 3 。

-1 + 1 + 1 + 1 + 1 = 3

+1 - 1 + 1 + 1 + 1 = 3

+1 + 1 - 1 + 1 + 1 = 3

+1 + 1 + 1 - 1 + 1 = 3

+1 + 1 + 1 + 1 - 1 = 3

示例 2:

输入:nums = 1, target = 1

输出:1

提示:

1 <= nums.length <= 20

0 <= numsi <= 1000

0 <= sum(numsi) <= 1000

-1000 <= target <= 1000

思路

一开始想着直接回溯的,就直接ac了,非常简单,在我的第一版代码里。但这个是在代码随想录01背包里的问题,所以要思考怎么转化为背包。实际上01背包很多题都是把数组拆成几组,这里就是两组一组a是用来做正数,另一组b做负数。那么两者a+b=sum,a-b=target,二式相加后可知就是找到把num数组中所有数之和为(sum+target)/2的方案,这里有两个坑,其中一个是sum+target要是偶数才行,另一个写在了代码注释里

代码

复制代码
// 第一版
class Solution {
    int res = 0;
    int sum = 0;
    public int findTargetSumWays(int[] nums, int target) {
        dfs(nums, 0, target);
        return res;
    }

    public void dfs(int[] nums, int idx, int target) {
        if (idx == nums.length) {
            if (sum == target) {res += 1;}
            return;
        }
        sum += nums[idx];
        dfs(nums, idx + 1, target);
        sum -= nums[idx];
        sum -= nums[idx];
        dfs(nums, idx + 1, target);
        sum += nums[idx];
    }
}
// 第二版
class Solution {
    public int findTargetSumWays(int[] nums, int target) {
        int n = nums.length, sum = 0;
        for (int i=0;i<n;i++) {
            sum += nums[i];
        }
        if (sum < Math.abs(target) || ((sum + target) & 1) == 1) {return 0;}
        int m = (sum + target) >> 1;
        int[][] f = new int[n+1][m+1];
        // 这是必要的,因为你之前都是求总和最大,所以i=0或者j=0的时候就是0,因为没得可装或者装不进去东西
        // 但现在是求方案数,所以没东西可装又j=0时候是1,也就是什么都不装
        // 但j要从0开始遍历,否则所有不装的方案都没记录下来
        f[0][0] = 1;
        // 注意这里不能直接这么初始化,因为可能nums数组有0元素,不一定体积为0时候不能装
        // for (int i=0;i<=n;i++) {f[i][0] = 1;}
        for (int i=1;i<=n;i++) {
            for (int j=0;j<=m;j++) {
                if (nums[i-1] > j) {f[i][j] = f[i-1][j];}
                else {f[i][j] = f[i-1][j] + f[i-1][j-nums[i-1]];}
            }
        }
        return f[n][m];
    }
}
相关推荐
其实防守也摸鱼12 小时前
个人学习 Pwn 思路:从基础到漏洞利用的进阶路径
大数据·前端·人工智能·chrome·算法·安全·网络安全
Nuanyt13 小时前
LeetCode Hot 100 链表专题(五)· 2 题(Java)
java·算法·leetcode·链表
w_zero_one16 小时前
递归算法(一)
java·开发语言·算法
圣保罗的大教堂16 小时前
leetcode 3736. 最小操作次数使数组元素相等 III 简单
leetcode
文丑颜不良啊17 小时前
LeetCode1881~1990题目解析
java·leetcode
风影同志7832417 小时前
20 个比特能装下多少行情?——实测拆解 Kronos 的 K 线分词器
算法
写的都是BUG18 小时前
APK 里的钥匙,一直就放在门口:聊聊加固真正该做什么
前端·算法
地平线开发者18 小时前
CLIP 的零样本分类:一组文本如何变成图像分类器?
算法
京东云开发者19 小时前
从“会生成”到“能生产”:萤火虫 AIGC 平台的 AI Infra 实践
算法·aigc·产品